//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Interop.Server.StructureDataTypeTest
{
    
    
    /// <summary>
    /// A class that exposes the IStructureDataTypeTest interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class StructureDataTypeTestProvider : IFeatureProvider
    {
        
        private IStructureDataTypeTest _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(StructureDataTypeTestProvider).Assembly, "StructureDataTypeTest.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public StructureDataTypeTestProvider(IStructureDataTypeTest implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<EchoStructureValueRequestDto, EchoStructureValueResponseDto>("EchoStructureValue", EchoStructureValue);
            registration.RegisterUnobservableCommand<EchoDeepStructureValueRequestDto, EchoDeepStructureValueResponseDto>("EchoDeepStructureValue", EchoDeepStructureValue);
            registration.RegisterUnobservableProperty("StructureValue", GetStructureValue);
            registration.RegisterUnobservableProperty("DeepStructureValue", GetDeepStructureValue);
        }
        
        /// <summary>
        /// Executes the Echo Structure Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoStructureValueResponseDto EchoStructureValue(EchoStructureValueRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoStructureValueResponseDto(_implementation.EchoStructureValue(request.StructureValue.TryExtract(_server, "org.silastandard/test/StructureDataTypeTest/v1/Command/EchoStructureValue/Paramet" +
                                "er/StructureValue")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "structureValue"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/StructureDataTypeTest/v1/Command/EchoStructureValue/Paramet" +
                            "er/StructureValue", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Executes the Echo Deep Structure Value command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EchoDeepStructureValueResponseDto EchoDeepStructureValue(EchoDeepStructureValueRequestDto request)
        {
            try
            {
                request.Validate();
                return new EchoDeepStructureValueResponseDto(_implementation.EchoDeepStructureValue(request.DeepStructureValue.TryExtract(_server, "org.silastandard/test/StructureDataTypeTest/v1/Command/EchoDeepStructureValue/Par" +
                                "ameter/DeepStructureValue")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "deepStructureValue"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/test/StructureDataTypeTest/v1/Command/EchoDeepStructureValue/Par" +
                            "ameter/DeepStructureValue", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            }
        }
        
        /// <summary>
        /// Gets the current value of the Structure Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<TestStructureDto> GetStructureValue()
        {
            return new PropertyResponse<TestStructureDto>(new TestStructureDto(_implementation.StructureValue, _server));
        }
        
        /// <summary>
        /// Gets the current value of the Deep Structure Value property
        /// </summary>
        /// <returns>The current value wrapped in a data transfer object</returns>
        protected virtual PropertyResponse<DeepStructureDto> GetDeepStructureValue()
        {
            return new PropertyResponse<DeepStructureDto>(new DeepStructureDto(_implementation.DeepStructureValue, _server));
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/test/StructureDataTypeTest/v1/Command/EchoStructureValue"))
            {
                return typeof(IStructureDataTypeTest).GetMethod("EchoStructureValue");
            }
            if ((commandIdentifier == "org.silastandard/test/StructureDataTypeTest/v1/Command/EchoDeepStructureValue"))
            {
                return typeof(IStructureDataTypeTest).GetMethod("EchoDeepStructureValue");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            if ((propertyIdentifier == "org.silastandard/test/StructureDataTypeTest/v1/Property/StructureValue"))
            {
                return typeof(IStructureDataTypeTest).GetProperty("StructureValue");
            }
            if ((propertyIdentifier == "org.silastandard/test/StructureDataTypeTest/v1/Property/DeepStructureValue"))
            {
                return typeof(IStructureDataTypeTest).GetProperty("DeepStructureValue");
            }
            return null;
        }
    }
}

